diff --git a/src/backend/utils/mb/wchar.c b/src/backend/utils/mb/wchar.c
index 1755be5..16e6cfd 100644
--- a/src/backend/utils/mb/wchar.c
+++ b/src/backend/utils/mb/wchar.c
@@ -380,6 +380,7 @@ pg_wchar2euc_with_len(const pg_wchar *from, unsigned char *to, int len)
 			*to++ = *from;
 			cnt++;
 		}		
+		from++;
 		len--;
 	}
 	*to = 0;
@@ -519,6 +520,7 @@ pg_wchar2utf_with_len(const pg_wchar *from, unsigned char *to, int len)
 		unicode_to_utf8(*from, to);
 		char_len = pg_utf_mblen(to);
 		len--;
+		from++;
 		cnt += char_len;
 		to += char_len;
 	}
@@ -854,6 +856,7 @@ pg_wchar2mule_with_len(const pg_wchar *from, unsigned char *to, int len)
 			*to++ = lb;
 			cnt += 1;
 		}
+		from++;
 		len--;
 	}
 	*to = 0;